// Modified by Walter Fordham 12/1/2013
// Added interpolation from Mladen
// Added MTF modifications

#property copyright "Copyright  2012, Isotope"
#property link      "https://twitter.com/IsotopeFX"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Aqua
#property indicator_width1 1
#property indicator_width2 1
#property indicator_style1 2
#property indicator_style2 2


extern int TimeFrame1=0,
           TimeFrame2=0,
           Period1=9,
           Period2=76;
extern string Method="0=SMA,1=EMA,2=SMMA,3=LWMA";
extern int Method1=1,
           Method2=3;
extern string Price="0=Close,1=Open,2=High,3=Low,4=Median,5=Typical,6=Weighted";  
extern int Price1=0,
           Price2=6;
extern int    Interpolate   = 2;

double MA1[],MA2[];//,Cloud1[],Cloud2[];

int init()
  {
   datetime TimeArray1[],TimeArray2[];
  ArrayCopySeries(TimeArray1,MODE_TIME,Symbol(),TimeFrame1); 
  ArrayCopySeries(TimeArray2,MODE_TIME,Symbol(),TimeFrame2); 

   SetIndexBuffer(0,MA2);
   SetIndexBuffer(1,MA1);
   
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   
   SetIndexLabel(0,NULL); 
   SetIndexLabel(1,NULL); 
   if (TimeFrame1==0||TimeFrame1<Period())
   {
   if(Period()==43200)
    {Alert("Cannot work correctly on this timeframe.");
     Alert("Please change the timeframe W1 or less :D");}
   if(Period()==10080)
    {TimeFrame1=43200;}
   if(Period()==1440)
    {TimeFrame1=10080;}
   if(Period()==240)
    {TimeFrame1=1440;}
   if(Period()==60)
    {TimeFrame1=240;}
   if(Period()==30)
    {TimeFrame1=60;}
   if(Period()==15)
    {TimeFrame1=30;}
   if(Period()==5)
    {TimeFrame1=15;}
   if(Period()==1)
    {TimeFrame1=5;}
   }
   if (TimeFrame2==0||TimeFrame2<TimeFrame1) TimeFrame2=TimeFrame1;
   return(0);
  }

int start()
  {
   int    i,shift,limit1,limit2,y=0,counted_bars=IndicatorCounted();
    
   
   limit1=Bars-counted_bars+TimeFrame1/Period();
   limit2=Bars-counted_bars+TimeFrame2/Period();
   
   for(i=limit1,y=0;i>=0;i--)
   { MathRound(MA1[i]);
//   if (Time[i]<TimeArray1[y]) y++; 

   MA1[i]=iMA(NULL,TimeFrame1,Period1,0,Method1,Price1,iBarShift(Symbol(),TimeFrame1,Time[i])); 
   if (Interpolate!=1&&Interpolate!=2) continue;
         if (iBarShift(NULL,TimeFrame1,Time[i])!=iBarShift(NULL,TimeFrame1,Time[i-1])) 
            interpolate(MA1,TimeFrame1,i,Interpolate);
   
   }  
   
   
   for(i=limit2,y=0;i>=0;i--)
   {
//   if (Time[i]<TimeArray2[y]) y++; 

   MA2[i]=iMA(NULL,TimeFrame2,Period2,0,Method2,Price2,iBarShift(Symbol(),TimeFrame2,Time[i]));
   
   
   if (Interpolate!=1&&Interpolate!=2) continue;
   
         if (iBarShift(NULL,TimeFrame2,Time[i])!=iBarShift(NULL,TimeFrame2,Time[i-1])) 
            interpolate(MA2,TimeFrame2,i,Interpolate);
   
   }  
  
   return(0);
  }
//+------------------------------------------------------------------+

void interpolate(double& target[], int timeFrame, int i, int interpolateType)
{
   int t = iBarShift(NULL,timeFrame,Time[i]); 
      double y0 = target[i];
      double y1 = target[iBarShift(NULL,0,iTime(NULL,timeFrame,t+0))+1];
      double y2 = target[iBarShift(NULL,0,iTime(NULL,timeFrame,t+1))+1];

      //
      //
      //
      //
      //
      
      datetime time = iTime(NULL,timeFrame,t);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
         for(int k = 1; k < n; k++)
         if (interpolateType==2)
         {
            double x3 = 1.0*k/n;
               target[i+k]  = y0*(x3-1.0)*(x3-2.0)/(-1.0*(-2.0))+
                              y1*(x3-0.0)*(x3-2.0)/( 1.0*(-1.0))+
		                        y2*(x3-0.0)*(x3-1.0)/( 2.0*( 1.0));         
         }
         else target[i+k] = target[i] + (target[i+n] - target[i])*k/n;
}

